;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
;///////////////////////////////////////////////////////////////////
;Product:     CyberFanatic LT
;Version:     in-progress
;Last Update: December 2002
;Status:      Freeware
;Author:      Ramir, mailto:anb@tut.by,Gomel,Belarus
;///////////////////////////////////////////////////////////////////
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\





;;;=====================================================
;;;  Common function for CyberFanatic system
;;;=====================================================






;;;====================================
;;;Save and recover parameters function 
;;;====================================

(defun *error* (msg)
(if old_error (setq *error* old_error));if
(if msg 
(progn
(princ msg)
(print "Unexpected error occured.")
(SETPARAM)
);progn
);if
);defun


(defun GETPARAM ( / version)
(setq old_error *error*)
(setq version (substr (getvar "ACADVER") 1 2))
(if (/= version "14")
(setq mode-autosnap (getvar "AUTOSNAP"))
);if
(if (/= (getvar "OSMODE") 0) (setq mode-osnap (getvar "OSMODE")));if
(setq mode-layer (getvar "CLAYER"))
(setq mode-ortho (getvar "ORTHOMODE"))
(setq mode-dimasz (getvar "DIMASZ"))
(setvar "OSMODE" 0)
(setvar "DIMASZ" 3.5)
(if (/= version "14")(setvar "AUTOSNAP" 3));if
);defun



(defun SETPARAM ( / version)
(if (/= mode-layer nil) (setvar "CLAYER" mode-layer))
;(setvar "OSMODE" mode-osnap)
(setvar "OSMODE" 45)
(setq version (substr (getvar "ACADVER") 1 2))
;(if (/= version "14")(setvar "AUTOSNAP" mode-autosnap));if
(if (/= version "14")(setvar "AUTOSNAP" 43));if
(setvar "PICKBOX" 5)
(setvar "ORTHOMODE" mode-ortho)
(setvar "DIMASZ" mode-dimasz)
);defun

;;;====================================
;;;====================================













(defun TAN (andrey)
(setq andrey (/ (sin andrey) (cos andrey)))
);defun-TAN


(defun MYRAD (andrey)
(setq andrey (* (/ pi 180) andrey))
);defun-TAN

(defun MYDAR (andrey)
(setq andrey (/ (* 180 andrey) pi))
);defun-TAN


(defun ROUND (z / z_int ost z)
(setq z_int (fix z))
(setq ost (- z z_int))
(if (>= ost 0.5) (setq z (+ z_int 1)) (setq z z_int));if
z
);defun






(setq hstep1 1)
(setq hstep2 2)
(setq hstep3 3)
(setq hstep4 4)
(setq hstep5 5)
(setq hstep6 6)
(setq hstep# 5)




(setq cf-path (findfile "mathemat.lsp"))
(setq cf-path (substr cf-path 1 (- (strlen cf-path) 12) ))


;radian angles
(setq x0 0)
(setq x20 (/ pi 9))
(setq x30 (/ pi 6))
(setq x45 (/ pi 4))
(setq x60 (/ pi 3))
(setq x90 (/ pi 2))
(setq x120 (* (/ pi 3) 2))
(setq x135 (+ (/ pi 2) (/ pi 4)))
(setq x150 (+ (/ pi 2) (/ pi 3)))
(setq x180 pi)
(setq x210 (+ pi (/ pi 6)))
(setq x225 (+ pi (/ pi 4)))
(setq x270 (/ (* pi 3) 2))
(setq x315 (+ pi (/ pi 2) (/ pi 4)))
(setq x330 (+ pi (/ pi 2) (/ pi 3)))
(setq x360 (* pi 2))

;Sets running Object Snap modes using the following bitcodes. 
;0  NONe
;1  ENDpoint
;2  MIDpoint
;4  CENter
;8  NODe
;16  QUAdrant
;32  INTersection
;64  INSertion
;128  PERpendicular
;256  TANgent
;512  NEArest
;1024  QUIck
;2048  APParent Intersection
;4096    EXTension
;8192    PARallel


;(setq osmode-param (+ 1    ;ENDpoint
;                      4    ;CENter
;                      8    ;NODe
;                      32   ;INTersection
;                      4096 );EXTension

;0  Turns off the AutoSnap marker, tooltips, and magnet. 
;   Also turns off polar tracking, object snap tracking, 
;   and tooltips for polar and object snap tracking
;1  Turns on the AutoSnap marker
;2  Turns on the AutoSnap tooltips
;4  Turns on the AutoSnap magnet
;8  Turns on polar tracking
;16 Turns on object snap tracking
;32 Turns on tooltips for polar tracking and object snap tracking 

;(setq autosnap-param  (+ 1 2 8 32);=43







;Initial toggles
;---------------------
(command "UNDO" "A" "OFF")
(setvar "PICKSTYLE" 0)
(setvar "OSMODE" (+ 1 4 8 32));=45
(setvar "HPNAME" "ANSI31")
(setq ver (substr (getvar "ACADVER") 1 2))
(if (/= ver "14")(setvar "AUTOSNAP" (+ 1 2 8 32)));if =43

;(setvar "PDMODE" 3)
;(command "VIEWRES" "Y" 20000)
;(command "UCSICON" "OFF")


;---------------------
;AUTOSNAP parameters
;Initial value: 63
;0	Turns off the AutoSnap marker, tooltips, and magnet. Also turns off polar tracking, object snap tracking, and tooltips for polar and object snap tracking
;1	Turns on the AutoSnap marker
;2	Turns on the AutoSnap tooltips
;4	Turns on the AutoSnap magnet
;8	Turns on polar tracking
;16	Turns on object snap tracking
;32	Turns on tooltips for polar tracking and object snap tracking
;---------------------


;---------------------
;			OSMODE parameters
;			0	NONe
;			1	ENDpoint
;			2	MIDpoint
;			4	CENter
;			8	NODe
;			16	QUAdrant
;			32	INTersection
;			64	INSertion
;			128	PERpendicular
;			256	TANgent
;			512	NEArest
;			1024	QUIck
;			2048	APParent Intersection
;			4096	EXTension
;			8192	PARallel
;---------------------




(defun DST();search dimension style my-style
(setq flag nil)
(setq tlist (tblnext "DIMSTYLE" T))
(setq sname (cdr (assoc 2 tlist)))
(if (or (= sname "my-style") (= sname "MY-STYLE"))
(setq flag 1)
(progn
(while (setq tlist (tblnext "DIMSTYLE"))
(setq sname (cdr (assoc 2 tlist)))
(if (or (= sname "my-style") (= sname "MY-STYLE")) (setq flag 1));if
);while 
);progn
);if
(if (= flag 1) T nil);if
);defun


(defun FINDLAYER(la / flag);search layer la
(setq flag nil)
(setq tlist (tblnext "LAYER" T))
(setq sname (cdr (assoc 2 tlist)))
(if (= sname la)
(setq flag 1)
(progn
(while (setq tlist (tblnext "LAYER"))
(setq sname (cdr (assoc 2 tlist)))
(if (= sname la) (setq flag 1));if
);while 
);progn
);if
(if (= flag 1) T nil);if
);defun





(defun TUNE ();tune current drawing

;DIMENSION initial parameters
;---------------------------------------------------------------------
(setq base-dimlfac (getvar "DIMLFAC"))

(if (/= ver "14")
(if (DST) (command "-DIMSTYLE" "R" "my-style" ));if
(if (DST) (command "DIMSTYLE" "R" "my-style" ));if
);set current dim style my-style
(setvar "DIMASZ" 3.5);arrow size
(setvar "DIMCLRT"  7);dim text color 7-white
(setvar "DIMTXT" 3.5);dim text height
(setvar "DIMSHO"   1   );Update dimensions while dragging
(if (/= ver "14")(setvar "DIMAZIN"  2));angular trailing zero supression
(setvar "DIMZIN"    8);linear trailing zero supression
(setvar "DIMGAP"  1.0);gap from dim line to dim text
(setvar "DIMADEC"   4);angular decimal places
(setvar "DIMDEC"    4);linear decimal places
(setvar "DIMEXO"    0);offset dim-line from origin
(setvar "DIMTOH"    0);radial dimension text is horizontal/above
(setvar "DIMTIH"    0);linear dimension text is horizontal/above
(setvar "DIMUPT"    1);user posicioned text
;(command "-STYLE" "STANDARD" "TXT.SHX" 3.5 0.8 0 "N" "N" "N")
(if (/= ver "14")
(command "-DIMSTYLE" "s" "MY-STYLE" "Y" )
(command "DIMSTYLE" "s" "MY-STYLE" "Y" )
)if;save current dim style as "my-style"

;tune Text style
(if (/= ver "14") 
(command "-STYLE" "TXT@CAD" "TXT@CAD.SHX" 3.5 0.8 0 "N" "N" "N")
(command "-STYLE" "TXT_CAD" "TXT@CAD.SHX" 3.5 0.8 0 "N" "N" "N")
);if
(if (/= ver "14") 
(setvar "DIMTXSTY" "TXT@CAD")
(setvar "DIMTXSTY" "TXT_CAD")
);if

(command "INSERT" "templ" (list 0 0) 1 1 0)
(setvar "HPNAME" "ANSI31")
(setvar "DIMLFAC" base-dimlfac)
(graphscr)
(princ)
);defuntune



;(command "DIM" "DIMUPT"   "Off"      );User positioned text
;(command "DIM" "DIMZIN"   8         "EXIT");Zero suppression
;(command "DIM" "DIMASZ"   5.0000     );Arrow size
;(command "DIM" "DIMDEC"   4          );Decimal places
;(command "DIM" "DIMDLE"   0.0000     );Dimension line extension
;(command "DIM" "DIMDLI"   8.0000     );Dimension line spacing
;(command "DIM" "DIMEXE"   1.2500     );Extension above dimension line
;(command "DIM" "DIMEXO"   0.0000     );Extension line origin offset
;(command "DIM" "DIMFIT"   3          );Fit text
;(command "DIM" "DIMGAP"   1.8000     );Gap from dimension line to text; if negative - draw frame around text
;(command "DIM" "DIMJUST"  0          );Justification of text on dimension line
;(command "DIM" "DIMLFAC"  1.0000    "exit" );Linear unit scale factor
;(command "DIM" "DIMAUNIT" 0          );Angular unit format
;(command "DIM" "DIMBLK"   ""         );Arrow block name
;(command "DIM" "DIMBLK1"  ""         );First arrow block name
;(command "DIM" "DIMBLK2"  ""         );Second arrow block name
;(command "DIM" "DIMCEN"   2.5000     );Center mark size
;(command "DIM" "DIMCLRD"  "BYBLOCK"  );Dimension line and leader color
;(command "DIM" "DIMCLRE"  "BYBLOCK"  );Extension line color
;(command "DIM" "DIMCLRT"  "BYBLOCK"  );Dimension text color
;(command "DIM" "DIMSHO"   "On"       );Update dimensions while dragging
;(command "DIM" "DIMSTYLE" "MY-STYLE" );Current dimension style (read-only)
;(command "DIM" "DIMTAD"   1          );Place text above the dimension line
;(command "DIM" "DIMTIH"   "Off"      );Text inside extensions is horizontal
;(command "DIM" "DIMTIX"   "Off"      );Place text inside extensions
;(command "DIM" "DIMTOFL"  "On"       );Force line inside extension lines
;(command "DIM" "DIMTOH"   "Off"      );Text outside horizontal
;(command "DIM" "DIMTXSTY" "STANDARD-08");Text style
;(command "DIM" "DIMLIM"   "Off"      );Generate dimension limits
;(command "DIM" "DIMPOST"  ""         );Prefix and suffix for dimension text
;(command "DIM" "DIMRND"   0.0000     );Rounding value
;(command "DIM" "DIMSAH"   "Off"      );Separate arrow blocks
;(command "DIM" "DIMSCALE" 1.0000     );Overall scale factor
;(command "DIM" "DIMSD1"   "Off"      );Suppress the first dimension line
;(command "DIM" "DIMSD2"   "Off"      );Suppress the second dimension line
;(command "DIM" "DIMSE1"   "Off"      );Suppress the first extension line
;(command "DIM" "DIMSE2"   "Off"      );Suppress the second extension line
;(command "DIM" "DIMSOXD"  "Off"      );Suppress outside dimension lines
;(command "DIM" "DIMTDEC"  4          );Tolerance decimal places
;(command "DIM" "DIMTFAC"  1.0000     );Tolerance text height scaling factor
;(command "DIM" "DIMTM"    0.0000     );Minus tolerance
;(command "DIM" "DIMTOL"   "Off"      );Tolerance dimensioning
;(command "DIM" "DIMTOLJ"  1          );Tolerance vertical justification
;(command "DIM" "DIMTP"    0.0000     );Plus tolerance
;(command "DIM" "DIMTSZ"   0.0000     );Tick size
;(command "DIM" "DIMTVP"   0.0000     );Text vertical position
;(command "DIM" "DIMTXT"   2.5000     );Text height
;(command "DIM" "DIMTZIN"  0          );Tolerance zero suppression
;(command "DIM" "DIMUNIT"  8          );Unit format
;(command "DIM" "DIMALT"   "Off"      );Alternate units selected
;(command "DIM" "DIMALTD"  4          );Alternate unit decimal places
;(command "DIM" "DIMALTF"  0.0394     );Alternate unit scale factor
;(command "DIM" "DIMALTTD" 4          );Alternate tolerance decimal places
;(command "DIM" "DIMALTTZ" 0          );Alternate tolerance zero suppression
;(command "DIM" "DIMALTU"  8          );Alternate units
;(command "DIM" "DIMALTZ"  0          );Alternate unit zero suppression
;(command "DIM" "DIMAPOST" ""         );Prefix and suffix for alternate text
;(command "DIM" "DIMASO"   "On"       );Create associative dimensions
;----------------------------------------------------------------------

;DIMTMOVE - allow you freelly move a dim-text along a dim-line during dimensioning. !!!
;DIMUPT must be "ON"


;Determine the zoom-button number in you mnc-file and write it on the disk
;to explore later by function with the "grread" operator
(defun CALIBER (/ k pt e nabor name len name1 nameprev flag spis)
(setq k 0)
(setq cf-path (findfile "mathemat.lsp"))
(setq len (strlen cf-path))
(setq cf-path (substr cf-path 1 (- len 12) ))
(setq cf-path1 (strcat cf-path "dynamic.ini"))
(setq fini   (open  cf-path1 "w"))
(princ "Click on buttons you need(to terminate click on graphik field:")
(princ "1 - zoom Window")
(princ "2 - zoom Previous")
(princ "3 - zoom Extents")
(princ "4 - Pan ")
(princ "5 - zoom Realtime")
(setq i 0)
(while (/= k 1)
(setq e  (grread 1 5 2))
(setq z e)
(setq flag (car z))
(cond
;===========
;===========
;===========
;---------------------------Mouse go on graphic field-------------------------
((= flag 5)
(progn
);progn
);e=5
;---------------------------Keyboard input--------------------------
((= flag 2)
(progn
);progn
);E=3

;---------------------------Click on graphic field--------------------------
((= flag 3)
(progn
(setq k 1)
);progn
);E=3
;---------------------------Mouse click on button---------------------------
((= flag 11)
(progn
(setq s (cadr z))
(print s)
(setq i (+ i 1))
(setq s (strcat "(setq nz" (itoa i) " " (itoa s) ")"))
(write-line s fini)
);progn
);E=11
;===========
;===========
;===========
);cond

);while
(close fini)
);DEFUN







(defun DEFINE-NBR (name / name1 nbr1)
				(setq nbr1 nil)
				(setq nbr1 (ssadd))
				(setq i 0)
				(while (= i 0)
				(setq name1 (entnext name))
				(if (/= name1 nil)
				(progn
				(setq nbr1 (ssadd name1 nbr1)) 
				(setq name name1) 
				);progn
				(setq i 1)
				);if
				);while
				nbr1
);defun

;delete nbr
(defun DEL-NBR (nbr / i name len)
(setq i 0)
(setq len (sslength nbr))
(while (< i len)
(setq name (ssname nbr i))
(entdel name)
(setq i (+ i 1))
);while
);defun

;unhighlite nbr
(defun R-3-NBR (nbr / i name len)
(setq i 0)
(setq len (sslength nbr))
(while (<= i len)
(setq name (ssname nbr i))
(if (/= name nil) (redraw name 3));if
(setq i (+ i 1))
);while
);defun

;highlite nbr
(defun R-4-NBR (nbr / i name len)
(setq i 0)
(setq len (sslength nbr))
(while (< i len)
(setq name (ssname nbr i))
(redraw name 4)
(setq i (+ i 1))
);while
);defun


;determine: exist or not exist name in nbr
(defun EXIST-IN-NBR (nbr name / i len)
(if (/= nbr nil)
(progn
(setq i 0)
(setq len (sslength nbr))
(while (< i len)
(setq name1 (ssname nbr i))
(if (eq name1 name)
(progn
(setq i len)
T
);progn
(progn
(setq i (+ i 1))
nil
);progn
);if
);while
);progn
);if
);defun







;distance between two lines
(defun DISTLINE (ame1 ame2 / data1 1pt10 1pt11 data2 2pt10 2pt11 ang p1 p2 pint )
(setq data1 (entget ame1))
(setq 1pt10 (cdr (setq sub10 (assoc 10 data1))))
(setq 1pt11 (cdr (setq sub11 (assoc 11 data1))))
(setq data2 (entget ame2))
(setq 2pt10 (cdr (setq sub10 (assoc 10 data2))))
(setq 2pt11 (cdr (setq sub11 (assoc 11 data2))))
(setq ang (angle 1pt10 1pt11))
(if (>= ang pi) (setq ang (- ang pi)));if
(setq p1 (polar 1pt10 (+ ang x90) 500))
(setq p2 (polar 1pt10 (- ang x90) 500))
(setq pint (inters p1 p2 2pt10 2pt11 nil))
(distance 1pt10 pint)
);defun


;create the block and user manually insert it in drawing
(defun MAKEBLOCK (nbr / ip name len )
(setq ip (list (CAR (GETVAR "VIEWCTR")) (CADR (GETVAR "VIEWCTR")) ))
(setq name (rtos (getvar "CDATE") 2 9))
(setq len (strlen name))
(setq name (substr name (- len 6) 6))
(command "BLOCK" name ip nbr "")
(command "INSERT" name pause 1 1 pause)
(princ)
);defun


;create the block and automatically insert in drawing in center of the screen
(defun MAKEBLOCK1 (nbr / ip name len)
(setq ip (list (CAR (GETVAR "VIEWCTR")) (CADR (GETVAR "VIEWCTR")) ))
(setq name (rtos (getvar "CDATE") 2 9))
(setq len (strlen name))
(setq name (substr name (- len 6) 6))
(command "BLOCK" name ip nbr "")
(command "INSERT" name ip 1 1 0)
(princ)
);defun

;create the block and automatically insert in drawing in p-point
(defun MAKEBLOCK2 (nbr p / name len ip)
(setq ip (list (CAR (GETVAR "VIEWCTR")) (CADR (GETVAR "VIEWCTR")) ))
(setq name (rtos (getvar "CDATE") 2 9))
(setq len (strlen name))
(setq name (substr name (- len 6) 6))
(command "BLOCK" name ip nbr "")
(command "INSERT" name p 1 1 0)
(princ)
);defun




(defun GETPOINT1 (mode / p)
(command "POINT" mode pause)
(setq name (entlast))
(setq data (entget name))
(setq ent (cdr (assoc 0 data)))
(if (= ent "POINT")
(progn
(setq p (cdr (assoc 10 data)))
(setq p (list (car p) (cadr p)))
(entdel name)
);progn
);if
p
);defun







(defun PNT ()
(setq point (getpoint "Pick insert point:"))
(setq p1 (list (+ (car point) 1) (+ (cadr point) 1)))
(setq p2 (list (+ (car p1) 61) (cadr p1)))
(GETPARAM)
(command "LAYER" "S" "DWG" "")
(princ)
);defun

(defun DPT ()
(setq p1 (list (car p1)(- (cadr p1) 8) ) p2 (list (car p2) (- (cadr p2) 8) ))
);defun





(defun GET-TEXT-RECT (name delta / data sub10 p10 tbx pc p1 p2 p3 p4 len)
(setq data (entget name))
(setq sub10 (assoc 10 data))
(setq p10 (list (car (cdr sub10)) (cadr (cdr sub10))))
(setq TBX (textbox data))
(command "_.ucs" "_object" name) ; set UCS to object
(setq p1 (list (car (car TBX)) (cadr (car TBX)) ))
(setq pc p1)
(setq p2 (list (car (cadr TBX)) (cadr (cadr TBX))))
(setq p1 (polar p1 x180 delta))
(setq p1 (polar p1 x270 delta))
(setq p2 (polar p2 x0   delta))
(setq p2 (polar p2 x90  delta))
(setq p3 (list (car p1) (cadr p2)))
(setq p4 (list (car p2) (cadr p1)))
;(command "PLINE" p1 p3 p2 p4 "c")
(setq len (distance p1 p4))
(command "_.ucs" "WORLD")
(princ)
(list p1 p2 p3 p4)
);defun


(defun TEXT-RECT (name delta / data sub10 p10 tbx pc p1 p2 p3 p4 len)
(setq data (entget name))
(setq sub10 (assoc 10 data))
(setq p10 (list (car (cdr sub10)) (cadr (cdr sub10))))
(setq TBX (textbox data))
(command "_.ucs" "_object" name) ; set UCS to object
(setq p1 (list (car (car TBX)) (cadr (car TBX)) ))
(setq pc p1)
(setq p2 (list (car (cadr TBX)) (cadr (cadr TBX))))
(setq p1 (polar p1 x180 delta))
(setq p1 (polar p1 x270 delta))
(setq p2 (polar p2 x0   delta))
(setq p2 (polar p2 x90  delta))
(setq p3 (list (car p1) (cadr p2)))
(setq p4 (list (car p2) (cadr p1)))
(command "PLINE" p1 p3 p2 p4 "c")
(command "_.ucs" "WORLD")
(princ)
);defun



(defun TEXT-RECT1 (name delta / len p0 #name #data #sub10 tbx p-1 p-1 p-3 p-4)
(setq p0 (list 0 0))
(setq data (entget name))
(setq str (cdr (assoc 1 data)))
(setq pn (cdr (assoc 10 data)))
(command "TEXT" p0 0 str)
(setq #name (entlast))
(setq #data (entget #name))
(setq #sub10 (assoc 10 #data))
(setq TBX (textbox #data))
(setq p1 (list (car (car TBX)) (cadr (car TBX)) ))
(setq pc p1)
(setq p2 (list (car (cadr TBX)) (cadr (cadr TBX))))
(setq p1 (polar p1 x180 delta))
(setq p1 (polar p1 x270 delta))
(setq p2 (polar p2 x0   delta))
(setq p2 (polar p2 x90  delta))
(setq p3 (list (car p1) (cadr p2)))
(setq p4 (list (car p2) (cadr p1)))
(command "PLINE" p1 p3 p2 p4 "c")
(setq name1 (entlast))
(entdel #name)
(command "MOVE" name1 "" p0 pn)
(princ)
);defun


(defun GET-TEXT-LEN (str / len p0 #name #data #sub10 tbx p-1 p-1 p-3 p-4)
(setq p0 (list 0 0))
(command "TEXT" p0 0 str)
(setq #name (entlast))
(setq #data (entget #name))
(setq #sub10 (assoc 10 #data))
(setq TBX (textbox #data))
(setq p-1 (list (car (car TBX)) (cadr (car TBX)) ))
(setq p-2 (list (car (cadr TBX)) (cadr (cadr TBX))))
(setq p-3 (list (car p-1) (cadr p-2)))
(setq p-4 (list (car p-2) (cadr p-1)))
(setq #len (distance p-1 p-4))
(entdel #name)
(princ)
#len
);defun


(defun GET-NAMETEXT-LEN (#name)
(setq #data (entget #name))
(setq TBX (textbox #data))
(setq p-1 (list (car (car TBX)) (cadr (car TBX)) ))
(setq p-2 (list (car (cadr TBX)) (cadr (cadr TBX))))
(setq p-3 (list (car p-1) (cadr p-2)))
(setq p-4 (list (car p-2) (cadr p-1)))
(setq #len (distance p-1 p-4))
(princ)
#len
);defun







(defun TEXT-UNDERLINE ($name delta / $data sub10 p10 str len $p1 $p2)
(setq $data (entget $name))
(setq sub10 (assoc 10 $data))
(setq p10 (list (car (cdr sub10)) (cadr (cdr sub10))))
(setq str (cdr (assoc 1 $data)))
(setq len (GET-TEXT-LEN str))
(setq $p1 (list (- (car p10) delta) (- (cadr p10) delta)))
(setq $p2 (polar $p1 x0 (+ (* delta 2) len )))
(command "LINE" $p1 $p2 "")
(princ)
);defun








;get the random string 
(defun GETNAME (/ name name1 len len1 str a i)
(setq name1 (rtos (getvar "CDATE") 2 9))
(setq len1 (strlen name1))
(setq name (substr name1 (- len1 6) 6))
(setq len (strlen name))
(setq i 0)
(setq str "")
(while (<= i len)
(setq i (+ i 1))
(setq a (substr name i 1))
(if (/= a ".")
(setq str (strcat str a))
(setq str (strcat str "0"))
);if
);while
str
);defun



(defun REMOVELST (lst m / i len spis)
(setq i 0)
(setq len (length lst))
(setq spis (list))
(while (< i len)
(if (not (equal m (nth i lst))) (setq spis (cons (nth i lst) spis)));if
(setq i (+ i 1))
);while
(setq spis (reverse spis))
);defun















